#!/usr/local/bin/luac53 -p --
--[[
--@brief  Quasi Robot Language; LuaChip
--@date   Sun,06 Sep,2020
--@date   Mon,21 Sep,2020
--@date   Sat,17 Oct,2020
--@date   Sat,30 Oct,2021
--@date   Sun,06 Mar,2022
--@date   Mon,09 Jan,2023
--@date   Mon,26 Jun,2023
--@date   Tue,27 Jun,2023
--@author Copyright(C)2020-2023 G-HAL
--]]

-- ##begin##
-- name : IF eq Module
-- size : 5 , 2
-- footprint :
-- #####
-- #####
-- address :
-- chip_coordinates_tag : ##010##
-- chip_number_tag : ##011##
-- chip_number : 
-- chip_footprint_tag : ##012##
-- next_address_condition_true_coordinates_tag : ##020##
-- next_address_condition_true_tag : ##021##
-- next_address_condition_true : 0010023
-- next_address_condition_false_coordinates_tag : ##030##
-- next_address_condition_false_tag : ##031##
-- next_address_condition_false : 0020023
-- argument : 2
-- argument_comment[1] : Module Type
-- argument[1] : Body
-- argument_tag[1] : ##111##
-- argument_type[1] : list
-- argument_list[1] : Body , Head , Arm , Leg , Wing , Tail , Turret , Storage , Conversion , Has Cockpit
-- argument_geometry[1] : x:104 , y:56 , w:265 , h:31
-- argument_comment[2] : Module
-- argument[2] : mod
-- argument_tag[2] : ##121##
-- argument_type[2] : var
-- argument_geometry[2] : x:89 , y:96 , w:123 , h:31
-- ##body##

function qrl_chip##011##(Mek, GB)
  PrintTraceMessage(GB, Mek, '##010##:##011##:IF_eq_Module');
  PrintTracer(GB, Mek, '##012##');
  if enable_debugger then
    dbg();
  end;
  if (c_Variable_Type_Module ~= g_QRL_UserVariable_Type["##121##"]) then
    PrintErrorMessage(GB, Mek, '##010##:##011##:IF_eq_Module:No module is selected.');
    return '##021##';
  end;

  if ("Has " == string.sub("##111##", 1, 4)) then
    local t = string.sub("##111##", 5);
    local switch = {
      default     = function(Mek, GB) PrintErrorMessage(GB, Mek, '##010##:##011##:IF_eq_Module:BUG.'); return false; end;
      ["Cockpit"] = function(Mek, GB) return (nil ~= SeekGear(Mek, GG_Cockpit, 0)); end;
    };
    if (switch[t] or switch.default)(Mek, GB) then
      return '##021##';
    end;
  else
    if (GS_##111## == Mek_S(g_QRL_UserVariable["##121##"])) then
      return '##021##';
    end;
  end;
  return '##031##';
end;

-- ##end##
-- [ End of File ]
